## kid3 3.6.1

=== src/qml/CMakeLists.txt ===
if (NOT HAVE_QMLDIR_IN_QRC)
# Before starting Qt Creator, export the environment variable
# QML_IMPORT_PATH=<qt5dir>/qml:<qt5dir>/imports
# so that the editor supports the QML types.
# On Linux, this can be done in ~/.xsessionrc.
set(qml_SUBDIRS script)
if (BUILD_QML_APP)
  set(qml_SUBDIRS ${qml_SUBDIRS} app)
endif (BUILD_QML_APP)

set(qml_QML_SRCS)
foreach (_subdir ${qml_SUBDIRS})
  include(${_subdir}/Sources.cmake)
  set(qml_QML_SRCS ${qml_QML_SRCS} ${${_subdir}_QML_SRCS})
  install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/${_subdir}
          DESTINATION ${WITH_QMLDIR}
          FILES_MATCHING PATTERN "*.qml" PATTERN "*.js")
endforeach (_subdir)
if (BUILD_QML_APP)
  install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/icons
          DESTINATION ${WITH_QMLDIR}
          FILES_MATCHING PATTERN "*.png" PATTERN "*.svg")
endif (BUILD_QML_APP)

# Only used to add the QML sources to the project.
add_custom_target(qml-sources SOURCES ${qml_QML_SRCS})

# Preprocess installed QML files for Qt 4 or Ubuntu Components.
if (NOT HAVE_QT5)
  set(_qmlpp_code 4)
  install(CODE "
    execute_process(
      COMMAND ${PYTHON_EXECUTABLE}
        ${kid3_SOURCE_DIR}/src/plugins/kid3qml/qmlpp.py ${_qmlpp_code}
      WORKING_DIRECTORY \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_QMLDIR}\"
    )
    ")
endif (NOT HAVE_QT5)
endif (NOT HAVE_QMLDIR_IN_QRC)

=== src/app/qt/CMakeLists.txt ===
set(qt_SRCS
  mainqt.cpp
  platformtools.cpp
  kid3mainwindow.cpp
  kid3qtapplication.cpp
  recentfilesmenu.cpp
  browserdialog.cpp
  messagedialog.cpp
  configdialog.cpp
  shortcutsmodel.cpp
  shortcutsdelegate.cpp
)
set(qt_MOC_HDRS
  kid3mainwindow.h
  kid3qtapplication.h
  recentfilesmenu.h
  browserdialog.h
  messagedialog.h
  configdialog.h
  shortcutsmodel.h
  shortcutsdelegate.h
)
qt4_wrap_cpp(qt_GEN_MOC_SRCS ${qt_MOC_HDRS})
set(qt_SRCS ${qt_SRCS} ${qt_GEN_MOC_SRCS})

if (APPLE)
  # Icon and properties for .plist file
  set(MACOSX_BUNDLE_BUNDLE_NAME "Kid3")
  set(MACOSX_BUNDLE_BUNDLE_EXECUTABLE "kid3")
  set(MACOSX_BUNDLE_ICON_FILE kid3.icns)
  set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${CPACK_PACKAGE_VERSION})
  set(MACOSX_BUNDLE_GUI_IDENTIFIER "net.sourceforge.kid3")
  set(MACOSX_BUNDLE_COPYRIGHT "Copyright (c) 2003-${RELEASE_YEAR} Urs Fleisch")
  set_source_files_properties(kid3.icns
    PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
  set(qt_SRCS ${qt_SRCS} kid3.icns)
  set_source_files_properties(qt.conf
    PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
  set(qt_SRCS ${qt_SRCS} qt.conf)
elseif (WIN32)
  if (MINGW)
    # support for Windows resource files with MinGW
    set(CMAKE_RC_COMPILER_INIT windres)
    enable_language(RC)
    set(CMAKE_RC_COMPILE_OBJECT
      "<CMAKE_RC_COMPILER> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
  endif (MINGW)
  # add Windows resource file with icon
  set(qt_SRCS ${qt_SRCS} kid3win.rc)
endif (APPLE)

if (UNIX AND NOT APPLE)
  find_program(GZIP_PROGRAM gzip)
  # install desktop file and icons for Linux
  add_custom_command(OUTPUT kid3-qt.desktop
    COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/fixdesktop.py
      <${CMAKE_CURRENT_SOURCE_DIR}/../kid3.desktop >kid3-qt.desktop
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../kid3.desktop
  )
  add_custom_target("desktop-file" ALL DEPENDS kid3-qt.desktop)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.desktop
    DESTINATION "${WITH_DATAROOTDIR}/applications")
  add_custom_command(OUTPUT kid3-qt.appdata.xml
    COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/fixappdata.py
      ${CMAKE_CURRENT_SOURCE_DIR}/../kid3.appdata.xml >kid3-qt.appdata.xml
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../kid3.appdata.xml
  )
  add_custom_target("appdata-file" ALL DEPENDS kid3-qt.appdata.xml)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.appdata.xml
    DESTINATION "${WITH_DATAROOTDIR}/metainfo")
  if (GZIP_PROGRAM)
    add_custom_command(OUTPUT kid3-qt.svg
      COMMAND ${GZIP_PROGRAM} -cdn ${CMAKE_CURRENT_SOURCE_DIR}/../hisc-apps-kid3.svgz >kid3-qt.svg
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../hisc-apps-kid3.svgz
    )
    set(qt_SRCS ${qt_SRCS} ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.svg)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.svg
            DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/scalable/apps")
  else (GZIP_PROGRAM)
    install(FILES ../hisc-apps-kid3.svgz
            DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/scalable/apps"
            RENAME kid3-qt.svgz)
  endif (GZIP_PROGRAM)
  install(FILES ../hi128-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/128x128/apps"
          RENAME kid3-qt.png)
  install(FILES ../hi64-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/64x64/apps"
          RENAME kid3-qt.png)
  install(FILES ../hi48-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/48x48/apps"
          RENAME kid3-qt.png)
  install(FILES ../hi32-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/32x32/apps"
          RENAME kid3-qt.png)
  install(FILES ../hi16-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/16x16/apps"
          RENAME kid3-qt.png)
elseif (APPLE)
  install(FILES ../hi48-apps-kid3.png
          DESTINATION ${WITH_DATAROOTDIR}
          RENAME kid3.png)
endif (UNIX AND NOT APPLE)

add_definitions(${QT_DEFINITIONS} ${QT_EXECUTABLE_COMPILE_FLAGS})
set(qt_RESOURCES kid3.qrc)
qt4_add_resources(qt_GEN_RCS ${qt_RESOURCES})
add_executable(${KID3_EXECUTABLE} MACOSX_BUNDLE WIN32
  ${qt_SRCS} ${qt_GEN_RCS})

target_link_libraries(${KID3_EXECUTABLE} kid3-gui -lstdc++)

if (APPLE)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/../../../macosx/Info.plist.in
                 ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
  set_target_properties(${KID3_EXECUTABLE} PROPERTIES
      MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
  if (CMAKE_CXX_COMPILER MATCHES "/osxcross/")
    # When cross compiling, CPack does not know that is should be APPLE.
    install(CODE "
  set(APPLE TRUE)
  ")
  endif ()
endif (APPLE)

install(TARGETS ${KID3_EXECUTABLE}
  BUNDLE DESTINATION .
  RUNTIME DESTINATION ${WITH_BINDIR})

if (LINUX_SELF_CONTAINED)
  # Change RPATH/RUNPATH of executable/library.
  macro(CHANGE_RPATH _rpath _file)
    install(CODE "
      execute_process(COMMAND chrpath -r ${_rpath} \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${_file}\")
      ")
  endmacro()

  set_target_properties(${KID3_EXECUTABLE} PROPERTIES INSTALL_RPATH "\$ORIGIN")
endif (LINUX_SELF_CONTAINED)

if (APPLE OR WIN32 OR LINUX_SELF_CONTAINED)

  # Put Qt libraries and plugins into installation package to create a
  # standalone bundle on Mac OS X and Windows
  set(plugin_dest_dir ${WITH_BINDIR})
  set(bundle_app
   "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_BINDIR}/${KID3_EXECUTABLE}")
  if (APPLE)
    set(plugin_dest_dir kid3.app/Contents/PlugIns)
    set(bundle_app "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/kid3.app")
  endif (APPLE)
  if (WIN32)
    set(bundle_app
      "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_BINDIR}/kid3.exe")
  endif (WIN32)
  string(REPLACE "/./" "/" bundle_app ${bundle_app})

  # Install Qt JPEG and Phonon plugins
  install(DIRECTORY "${QT_PLUGINS_DIR}/imageformats"
    DESTINATION ${plugin_dest_dir}
    FILES_MATCHING PATTERN "*jpeg${CMAKE_SHARED_LIBRARY_SUFFIX}"
                   PATTERN "*jpeg4${CMAKE_SHARED_LIBRARY_SUFFIX}"
                   PATTERN "*.dSYM" EXCLUDE)

  if (LINUX_SELF_CONTAINED)
    CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/imageformats/libqjpeg${CMAKE_SHARED_LIBRARY_SUFFIX}")
  endif ()
  if (HAVE_QT5)
    if (APPLE)
      install(DIRECTORY "${QT_PLUGINS_DIR}/platforms"
        DESTINATION kid3.app/Contents/MacOS
        FILES_MATCHING PATTERN "libqcocoa${CMAKE_SHARED_LIBRARY_SUFFIX}"
                       PATTERN "*.dSYM" EXCLUDE)
      install(DIRECTORY "${QT_PLUGINS_DIR}/mediaservice"
        DESTINATION ${plugin_dest_dir}
        FILES_MATCHING PATTERN "libqavfmediaplayer${CMAKE_SHARED_LIBRARY_SUFFIX}"
                       PATTERN "*.dSYM" EXCLUDE)
    elseif (WIN32)
      install(DIRECTORY "${QT_PLUGINS_DIR}/platforms"
        DESTINATION ${plugin_dest_dir}
        FILES_MATCHING PATTERN "qwindows${CMAKE_SHARED_LIBRARY_SUFFIX}")
      install(DIRECTORY "${QT_PLUGINS_DIR}/mediaservice"
        DESTINATION ${plugin_dest_dir}
        FILES_MATCHING PATTERN "dsengine${CMAKE_SHARED_LIBRARY_SUFFIX}")
    elseif (LINUX_SELF_CONTAINED)
      install(DIRECTORY "${QT_PLUGINS_DIR}/platforms"
        DESTINATION ${plugin_dest_dir}
        FILES_MATCHING PATTERN "libqxcb${CMAKE_SHARED_LIBRARY_SUFFIX}")
      CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/platforms/libqxcb${CMAKE_SHARED_LIBRARY_SUFFIX}")
      install(DIRECTORY "${QT_PLUGINS_DIR}/mediaservice"
        DESTINATION ${plugin_dest_dir}
        FILES_MATCHING PATTERN "libgstmediaplayer${CMAKE_SHARED_LIBRARY_SUFFIX}")
      CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/mediaservice/libgstmediaplayer${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif (APPLE)
  endif (HAVE_QT5)

  if (HAVE_PHONON)
    install(DIRECTORY "${QT_PLUGINS_DIR}/phonon_backend"
      DESTINATION ${plugin_dest_dir}
      FILES_MATCHING
        PATTERN "*d4${CMAKE_SHARED_LIBRARY_SUFFIX}" EXCLUDE
        PATTERN "*${CMAKE_SHARED_LIBRARY_SUFFIX}"
        PATTERN "*.dSYM" EXCLUDE)
  endif (HAVE_PHONON)

  if (CMAKE_CROSSCOMPILING AND NOT APPLE)
    # Avoid error "/usr/bin/ldd failed: 1" from GetPrerequisites.cmake:800
    # when cross-packaging, this does not seem to be supported.
    # https://public.kitware.com/pipermail/cmake/2012-March/049497.html
    install(CODE "
    set(gp_tool DO_NOT_USE)
    ")
  endif (CMAKE_CROSSCOMPILING AND NOT APPLE)

  # Install and fix up all dependencies of the executable and the plugins.
  # On Mac OS X only keep the i386 code in the Qt libraries and plugins.
  install(CODE "
    file(GLOB_RECURSE QTPLUGINS
      \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${plugin_dest_dir}/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
    if (APPLE)
      file(GLOB_RECURSE QTPLATFORMPLUGINS
        \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/kid3.app/Contents/MacOS/platforms/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
      set(QTPLUGINS \"\${QTPLUGINS};\${QTPLATFORMPLUGINS}\")
    endif (APPLE)
    file(GLOB_RECURSE KID3PLUGINS
      \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_PLUGINSDIR}/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
    include(BundleUtilities)
    set(bundle_libs \"\${QTPLUGINS};\${KID3PLUGINS}\")
    if (APPLE AND BUILD_CLI_APP)
      set(bundle_libs \"\${bundle_libs};\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_LIBDIR}/kid3-cli\")
    endif (APPLE AND BUILD_CLI_APP)
    fixup_bundle(\"${bundle_app}\" \"\${bundle_libs}\" \"${QT_LIBRARY_DIR}\")
    ")

endif (APPLE OR WIN32 OR LINUX_SELF_CONTAINED)

if (WIN32)
  if (NOT HAVE_QT5)
    # Unfortunately, the binutils which come with the gcc-4.4.0 in the MinGW
    # for Qt generate an executable which cannot be analyzed with dumpbin.
    # This happens when Kid3 is linked with libav (used with Chromaprint).
    # Therefore, the dependencies for kid3.exe are not added to the bundle.
    # This workaround adds the missing files.
    install(FILES "${QT_BINARY_DIR}/QtNetwork4.dll"
                  "${QT_BINARY_DIR}/QtXml4.dll"
                  "${QT_BINARY_DIR}/libwinpthread-1.dll"
                  "${QT_BINARY_DIR}/libiconv-2.dll"
            DESTINATION ${WITH_BINDIR})
  else (NOT HAVE_QT5)
    # Use reduced size ICU libraries, QTBUG-29828, QTBUG-38259.
    # A folder with reduced ICU libraries can be copied to the Qt bin directory.
    get_target_property(_qtBinDir Qt5::Core LOCATION)
    get_filename_component(_qtBinDir ${_qtBinDir} PATH)
    install(DIRECTORY "${_qtBinDir}/icu_reduced/"
            DESTINATION ${WITH_BINDIR} OPTIONAL)
    # Install missing DLLs.
    file(GLOB _sslDlls "${_qtBinDir}/../../../Tools/mingw*/opt/bin/*eay32.dll")
    install(FILES "${_qtBinDir}/Qt5Xml.dll" ${_sslDlls}
            DESTINATION ${WITH_BINDIR})
  endif (NOT HAVE_QT5)
endif (WIN32)

if (LINUX_SELF_CONTAINED)
  # Use reduced size ICU libraries.
  # A folder with reduced ICU libraries can be copied to the Qt bin directory.
  get_target_property(_qtBinDir Qt5::qmake LOCATION)
  get_filename_component(_qtBinDir ${_qtBinDir} PATH)
  string(REPLACE "/bin" "/lib" _qtLibDir "${_qtBinDir}")
  install(CODE "
    if (EXISTS \"${_qtLibDir}/icu_reduced\")
      file(GLOB _iculibs \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_BINDIR}/libicu*\")
      if (_iculibs)
        file(REMOVE \${_iculibs})
      endif ()
    endif ()
  ")
  install(DIRECTORY "${_qtLibDir}/icu_reduced/"
          DESTINATION ${WITH_BINDIR} OPTIONAL)
endif (LINUX_SELF_CONTAINED)

=== src/plugins/kid3qml/CMakeLists.txt ===
set(plugin_SRCS
  kid3qmlplugin.cpp
  qmlimageprovider.cpp
  scriptutils.cpp
  configobjects.cpp
  checkablelistmodel.cpp
)

set(plugin_MOC_HDRS
  kid3qmlplugin.h
  scriptutils.h
  configobjects.h
  checkablelistmodel.h
)

set(plugin_QML_SRCS
  Kid3Script.qml
)

set(plugin_NAME Kid3Qml)

if (WITH_GCC_PCH)
  add_definitions(${GCC_PCH_COMPILE_FLAGS})
endif (WITH_GCC_PCH)

string(TOLOWER ${plugin_NAME} plugin_TARGET)

qt4_wrap_cpp(plugin_GEN_MOC_SRCS ${plugin_MOC_HDRS})

set(_targetDependencies ${plugin_SRCS} ${plugin_GEN_MOC_SRCS}
  ${plugin_QML_SRCS} "${kid3_plugins_BINARY_DIR}/imports/Kid3/Kid3Script.qml")
if (APPLE)
  # The extension must be dylib, not so.
  add_library(${plugin_TARGET} SHARED ${_targetDependencies})
else (APPLE)
  add_library(${plugin_TARGET} MODULE ${_targetDependencies})
endif (APPLE)
target_link_libraries(${plugin_TARGET} kid3-core ${BASIC_LIBRARIES})

if (NOT HAVE_QMLDIR_IN_QRC)
  install(TARGETS ${plugin_TARGET}
    LIBRARY DESTINATION ${WITH_PLUGINSDIR}/imports/Kid3
    RUNTIME DESTINATION ${WITH_PLUGINSDIR}/imports/Kid3)
  set_target_properties(
    ${plugin_TARGET} PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${kid3_plugins_BINARY_DIR}/imports/Kid3
    LIBRARY_OUTPUT_DIRECTORY ${kid3_plugins_BINARY_DIR}/imports/Kid3
  )
else (NOT HAVE_QMLDIR_IN_QRC)
  install(TARGETS ${plugin_TARGET}
    LIBRARY DESTINATION ${WITH_BINDIR}
    RUNTIME DESTINATION ${WITH_BINDIR})
  file(MAKE_DIRECTORY "${kid3_plugins_BINARY_DIR}/imports/Kid3")
endif (NOT HAVE_QMLDIR_IN_QRC)
if (ANDROID)
  # Fix "-soname: must take a non-empty argument" error with CMake >= 3.2.
  # http://stackoverflow.com/questions/26841603/arm-linux-androideabi-bin-ld-fatal-error-soname-must-take-a-non-empty-argume
  string(REPLACE "<CMAKE_SHARED_LIBRARY_SONAME_CXX_FLAG><TARGET_SONAME>" ""
         CMAKE_CXX_CREATE_SHARED_MODULE "${CMAKE_CXX_CREATE_SHARED_MODULE}")
endif (ANDROID)

if (WIN32)
  set(_qmldirPluginName libkid3qml)
else (WIN32)
  set(_qmldirPluginName kid3qml)
endif (WIN32)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qmldir.in
               "${kid3_plugins_BINARY_DIR}/imports/Kid3/qmldir"
               @ONLY)
add_custom_command(OUTPUT "${kid3_plugins_BINARY_DIR}/imports/Kid3/Kid3Script.qml"
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/Kid3Script.qml "${kid3_plugins_BINARY_DIR}/imports/Kid3/"
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/Kid3Script.qml
  WORKING_DIRECTORY "${kid3_plugins_BINARY_DIR}/imports/Kid3"
)

# Preprocess QML files for Qt 4.
if (NOT HAVE_QT5)
  set(_qmlpp_code 4)
  add_custom_command(OUTPUT "${kid3_plugins_BINARY_DIR}/imports/Kid3/Kid3Script.qml"
    COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/qmlpp.py ${_qmlpp_code}
    WORKING_DIRECTORY "${kid3_plugins_BINARY_DIR}/imports/Kid3"
    APPEND
  )
endif (NOT HAVE_QT5)

install(FILES "${kid3_plugins_BINARY_DIR}/imports/Kid3/qmldir"
              "${kid3_plugins_BINARY_DIR}/imports/Kid3/Kid3Script.qml"
        DESTINATION ${WITH_PLUGINSDIR}/imports/Kid3)
if (NOT WIN32 AND NOT ANDROID)
  if (HAVE_QT5)
    get_target_property(_qmakeLocation Qt5::qmake LOCATION)
  else (HAVE_QT5)
    set(_qmakeLocation "${QT_QMAKE_EXECUTABLE}")
  endif (HAVE_QT5)
  execute_process(COMMAND "${_qmakeLocation}" -query QT_INSTALL_BINS
    OUTPUT_VARIABLE _qtInstallBins OUTPUT_STRIP_TRAILING_WHITESPACE)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/runqmlplugindump.cmake.in
                 ${CMAKE_CURRENT_BINARY_DIR}/runqmlplugindump.cmake
                 @ONLY)
  add_custom_command(OUTPUT "${kid3_plugins_BINARY_DIR}/imports/Kid3/plugins.qmltypes"
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/runqmlplugindump.cmake
    DEPENDS ${plugin_TARGET}
    WORKING_DIRECTORY "${kid3_plugins_BINARY_DIR}/imports/Kid3")
  add_custom_target(plugins_qmltypes ALL
    DEPENDS "${kid3_plugins_BINARY_DIR}/imports/Kid3/plugins.qmltypes")
  add_dependencies(plugins_qmltypes ${plugin_TARGET})

  install(FILES "${kid3_plugins_BINARY_DIR}/imports/Kid3/plugins.qmltypes"
          DESTINATION ${WITH_PLUGINSDIR}/imports/Kid3 OPTIONAL)
endif (NOT WIN32 AND NOT ANDROID)

if ((WIN32 OR APPLE) AND HAVE_QT5)
  # Install essential QML modules.
  get_target_property(QT_QML_DIR Qt5::qmake LOCATION)
  get_filename_component(QT_QML_DIR ${QT_QML_DIR} PATH)
  get_filename_component(QT_QML_DIR ${QT_QML_DIR} PATH)
  set(QT_QML_DIR ${QT_QML_DIR}/qml)
  install(DIRECTORY "${QT_QML_DIR}/QtQuick.2"
    DESTINATION "${WITH_PLUGINSDIR}/imports"
    FILES_MATCHING PATTERN "*plugin${CMAKE_SHARED_LIBRARY_SUFFIX}"
                   PATTERN "qmldir"
                   PATTERN "*.dSYM" EXCLUDE)
  install(DIRECTORY "${QT_QML_DIR}/QtQuick/Layouts"
    DESTINATION "${WITH_PLUGINSDIR}/imports/QtQuick"
    FILES_MATCHING PATTERN "*plugin${CMAKE_SHARED_LIBRARY_SUFFIX}"
                   PATTERN "qmldir"
                   PATTERN "*.dSYM" EXCLUDE)
endif ()

=== src/plugins/taglibmetadata/CMakeLists.txt ===
set(TAGLIB_LIBRARIES)
set(TAGLIB_CFLAGS)
if(WITH_TAGLIB)
  if (WIN32 OR CMAKE_CXX_COMPILER MATCHES "/osxcross/")
    find_library(TAGLIB_LIBRARIES NAMES tag)
    find_path(TAGLIB_INCLUDE_DIR taglib/taglib.h)
    if (TAGLIB_LIBRARIES AND TAGLIB_INCLUDE_DIR)
      set(TAGLIB_CFLAGS -I${TAGLIB_INCLUDE_DIR}/taglib -I${TAGLIB_INCLUDE_DIR} -DTAGLIB_STATIC)
      set(HAVE_TAGLIB 1)
      message(STATUS "TagLib found: ${TAGLIB_LIBRARIES}")
      set(TAGLIB_LIBRARIES ${TAGLIB_LIBRARIES} ${ZLIB_LIBRARIES})
    endif (TAGLIB_LIBRARIES AND TAGLIB_INCLUDE_DIR)
  else ()
    find_program(TAGLIBCONFIG_EXECUTABLE NAMES taglib-config PATHS /usr/bin /usr/local/bin ${BIN_INSTALL_DIR})
    if(TAGLIBCONFIG_EXECUTABLE)
      exec_program(${TAGLIBCONFIG_EXECUTABLE} ARGS --libs RETURN_VALUE _return_VALUE OUTPUT_VARIABLE TAGLIB_LIBRARIES)
      exec_program(${TAGLIBCONFIG_EXECUTABLE} ARGS --cflags RETURN_VALUE _return_VALUE OUTPUT_VARIABLE TAGLIB_CFLAGS)
      exec_program(${TAGLIBCONFIG_EXECUTABLE} ARGS --version RETURN_VALUE _return_VALUE OUTPUT_VARIABLE TAGLIB_VERSION)
      if(TAGLIB_LIBRARIES AND TAGLIB_CFLAGS AND TAGLIB_VERSION)
        if(NOT ${TAGLIB_VERSION} VERSION_LESS 1.4)
          set(HAVE_TAGLIB 1)
          message(STATUS "TagLib found: ${TAGLIB_LIBRARIES}")
          set(TAGLIB_LIBRARIES ${TAGLIB_LIBRARIES} ${ZLIB_LIBRARIES} -lstdc++)
        endif(NOT ${TAGLIB_VERSION} VERSION_LESS 1.4)
      endif(TAGLIB_LIBRARIES AND TAGLIB_CFLAGS AND TAGLIB_VERSION)
    endif(TAGLIBCONFIG_EXECUTABLE)
  endif ()
  if (NOT HAVE_TAGLIB)
    message(FATAL_ERROR "Could not find Taglib")
  endif (NOT HAVE_TAGLIB)
endif(WITH_TAGLIB)
if (TAGLIB_LIBRARIES AND TAGLIB_CFLAGS)
  set(_CMAKE_REQUIRED_LIBRARIES_TMP ${CMAKE_REQUIRED_LIBRARIES})
  set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} ${TAGLIB_LIBRARIES})
  set(_CMAKE_REQUIRED_DEFINITIONS_TMP ${CMAKE_REQUIRED_DEFINITIONS})
  set(CMAKE_REQUIRED_DEFINITIONS ${CMAKE_REQUIRED_DEFINITIONS} ${TAGLIB_CFLAGS})
  CHECK_CXX_SOURCE_COMPILES("#include <mpegfile.h>\nint main() {\n  TagLib::MPEG::File file(\"somefile.mp3\");\n  file.save(3, false, 3);\n  return 0;\n}\n" HAVE_TAGLIB_ID3V23_SUPPORT)
  CHECK_CXX_SOURCE_COMPILES("#include <mpegfile.h>\n#include <xmfile.h>\nint main() {\n  TagLib::MPEG::File file(\"somefile.mp3\");\n  return dynamic_cast<TagLib::XM::Properties*>(file.audioProperties()) != 0;\n}\n" HAVE_TAGLIB_XM_SUPPORT)
  set(CMAKE_REQUIRED_LIBRARIES ${_CMAKE_REQUIRED_LIBRARIES_TMP})
  set(CMAKE_REQUIRED_DEFINITIONS ${_CMAKE_REQUIRED_DEFINITIONS_TMP})


  configure_file(taglibconfig.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/taglibconfig.h)

  add_definitions(${TAGLIB_CFLAGS})
  include_directories(${CMAKE_CURRENT_BINARY_DIR} ../../core/tags taglibext)
  # The include from TAGLIB_CFLAGS is explicitly added as an include directory
  # so that Qt Creator knows about it.
  string(REGEX MATCH "-I *([^ ]+)" _taglibIncludeMatch ${TAGLIB_CFLAGS})
  if (_taglibIncludeMatch)
    include_directories(${CMAKE_MATCH_1})
  endif (_taglibIncludeMatch)


  set(plugin_SRCS
    taglibmetadataplugin.cpp
    taglibfile.cpp
    taglibext/aac/aacfiletyperesolver.cpp
    taglibext/mp2/mp2filetyperesolver.cpp
  )

  if (NOT ${TAGLIB_VERSION} VERSION_GREATER 1.9.1)
    set(plugin_SRCS ${plugin_SRCS}
      taglibext/synchronizedlyricsframe.cpp
      taglibext/eventtimingcodesframe.cpp
    )
  endif (NOT ${TAGLIB_VERSION} VERSION_GREATER 1.9.1)

  if (NOT ${TAGLIB_VERSION} VERSION_LESS 1.9.1)
    set(plugin_SRCS ${plugin_SRCS}
      taglibext/dsf/dsffiletyperesolver.cpp
      taglibext/dsf/dsffile.cpp
      taglibext/dsf/dsfproperties.cpp
      taglibext/dsf/dsfheader.cpp
    )
  endif (NOT ${TAGLIB_VERSION} VERSION_LESS 1.9.1)

  if (TAGLIB_VERSION STREQUAL "1.4")
    set(plugin_SRCS ${plugin_SRCS}
      taglibext/urllinkframe.cpp
      taglibext/unsynchronizedlyricsframe.cpp
      taglibext/generalencapsulatedobjectframe.cpp
      taglibext/speex/speexfile.cpp
      taglibext/speex/speexproperties.cpp
      taglibext/speex/taglib_speexfiletyperesolver.cpp
      taglibext/trueaudio/taglib_trueaudiofiletyperesolver.cpp
      taglibext/trueaudio/ttafile.cpp
      taglibext/trueaudio/ttaproperties.cpp
      taglibext/wavpack/taglib_wavpackfiletyperesolver.cpp
      taglibext/wavpack/wvfile.cpp
      taglibext/wavpack/wvproperties.cpp
    )
  endif (TAGLIB_VERSION STREQUAL "1.4")

  set(plugin_MOC_HDRS
    taglibmetadataplugin.h
  )

  set(plugin_NAME TaglibMetadata)

  if (WITH_GCC_PCH)
    add_definitions(${GCC_PCH_COMPILE_FLAGS})
  endif (WITH_GCC_PCH)

  string(TOLOWER ${plugin_NAME} plugin_TARGET)

  qt4_wrap_cpp(plugin_GEN_MOC_SRCS ${plugin_MOC_HDRS})

  add_library(${plugin_TARGET} ${plugin_SRCS} ${plugin_GEN_MOC_SRCS})
  target_link_libraries(${plugin_TARGET} kid3-core ${BASIC_LIBRARIES} ${TAGLIB_LIBRARIES})

  INSTALL_KID3_PLUGIN(${plugin_TARGET} ${plugin_NAME})
endif (TAGLIB_LIBRARIES AND TAGLIB_CFLAGS)

=== debian/changelog ===
kid3 (3.6.1-1build1) cosmic; urgency=medium

  * No-change rebuild for ffmpeg soname changes.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 19 Jul 2018 08:47:01 +0000

kid3 (3.6.1-1) unstable; urgency=medium

  * New upstream release.
    - Fixes FTCBFS.
      Closes: #900008
  * Add environment variables from the patch of #900008.
  * Replace build dependencies on deprecated framework packages.
    Closes: #885391
  * Bump Standards-Version to 4.1.4.
  * Move package to my own repository.
  * Remove upgrade option from debian/watch.
  * Move source.lintian-overrides file to source directory.
  * Remove trailing whitespace from debian/changelog.
  * Bump debian/compat to level 11.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 05 Jun 2018 14:29:54 +0200

=== debian/control ===
Source: kid3
Section: kde
Priority: optional
Maintainer: Patrick Matthäi <pmatthaei@debian.org>
Build-Depends: debhelper (>= 11),
 extra-cmake-modules,
 libkf5kio-dev,
 libkf5doctools-dev,
 qtmultimedia5-dev,
 qtdeclarative5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 qtdeclarative5-dev-tools,
 qml-module-qtquick2,
 cmake,
 libid3-3.8.3-dev,
 libflac++-dev,
 libvorbis-dev,
 libtag1-dev,
 libchromaprint-dev,
 libavformat-dev,
 libavcodec-dev,
 docbook-xsl,
 pkg-config,
 libreadline-dev,
 xsltproc
Standards-Version: 4.1.4
Homepage: http://kid3.sourceforge.net/

Package: kid3-core
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Breaks: kid3 (<< 3.0.2-2)
Replaces: kid3 (<< 3.0.2-2)
Description: Audio tag editor core libraries and data
 With Kid3, an ID3 tag editor for KDE you can:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit tags in MP3, Ogg/Vorbis, Opus, DSF, FLAC, MPC, APE, MP4/AAC, MP2,
    Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker modules.
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate tags from the contents of tag fields
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs, Amazon
 .
 This package contains common libraries and data used by both kid3 and kid3-qt.

Package: kid3
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 kid3-core (= ${binary:Version})
Description: KDE audio tag editor
 With Kid3, an ID3 tag editor for KDE you can:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit tags in MP3, Ogg/Vorbis, Opus, DSF, FLAC, MPC, APE, MP4/AAC, MP2,
    Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker modules.
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate tags from the contents of tag fields
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs, Amazon
 .
 This package uses KDE libraries, if you do not use KDE you should use kid3-qt.

Package: kid3-qt
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 kid3-core (= ${binary:Version})
Description: Audio tag editor
 With Kid3, an audio tag editor you can:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit tags in MP3, Ogg/Vorbis, Opus, DSF, FLAC, MPC, APE, MP4/AAC, MP2,
    Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker modules.
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate tags from the contents of tag fields
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs, Amazon
 .
 This package does not use KDE libraries, if you use KDE you should use kid3.

Package: kid3-cli
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 kid3-core (= ${binary:Version})
Breaks: kid3 (<< 3.0.2-2)
Replaces: kid3 (<< 3.0.2-2)
Description: Command line audio tag editor
 With Kid3, an audio tag editor you can:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit tags in MP3, Ogg/Vorbis, Opus, DSF, FLAC, MPC, APE, MP4/AAC, MP2,
    Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker modules.
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate tags from the contents of tag fields
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs, Amazon
 .
 This package contains a command line interface for Kid3, for a GUI you can
 use kid3-qt or kid3.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_CMAKE_PREFIX = /usr
DEB_CONFIG_INSTALL_DIR = $(DEB_CMAKE_PREFIX)/share/kde4/config
DEB_HTML_INSTALL_DIR = $(DEB_CMAKE_PREFIX)/share/doc/kde/HTML
BASE_CMAKE_DEFS = -DWITH_QT5=ON -DKDE_INSTALL_BINDIR=$(DEB_CMAKE_PREFIX)/bin -Wno-dev -DWITH_FFMPEG=ON

%:
	dh $@ --builddirectory=kid3-build

override_dh_auto_configure:
	dh_auto_configure -- \
		-DSYSCONF_INSTALL_DIR=/etc \
		-DCMAKE_INSTALL_PREFIX=$(DEB_CMAKE_PREFIX) \
		$(BASE_CMAKE_DEFS) \
		-DLIB_INSTALL_DIR=$(DEB_CMAKE_PREFIX)/lib/kid3 \
		-DCMAKE_C_FLAGS="$(CFLAGS)" \
		-DCMAKE_CXX_FLAGS="$(CXXFLAGS)"

override_dh_auto_build:
	dh_auto_build
	cp kid3-build/doc/en/kid3.1 kid3-build/doc/en/kid3-core.1
	cp kid3-build/doc/de/kid3.1 kid3-build/doc/de/kid3-core.de.1

override_dh_auto_install:
	dh_auto_install

override_dh_makeshlibs:
	dh_makeshlibs --noscripts

override_dh_compress:
	dh_compress --exclude=.docbook
